<template>
  <div class="order-request-execution">
    <ObForm
      :form-model="formModel"
      :form-data="formData"
      ok-text="Подтвердить"
      data-qa="confirmExecutionForm"
      @submit="onSubmitHandler"
    >
      <div class="row row-inputs">
        <div class="col-xs-6">
          <ObStepper
            v-model="formData.acceptedCount"
            label="Количество экземпляров в POD"
            min-value="1"
          />
        </div>
        <div class="col-xs-6">
          <ObDatePicker
            v-model="formData.receivingDate"
            label="Дата получения документов"
            data-qa="datetime"
            property="receivingDate"
          />
        </div>
      </div>
      <div class="title">Бумажные документы, связанные с событием</div>
      <ObUploader
        ref="uploader"
        data-qa="uploader"
        :upload-method="uploadMethod"
        @change="onUploadHandler"
      />
    </ObForm>
  </div>
</template>

<script>
  import { mapGetters } from 'vuex'
  import api from '@/api'
  import ObForm from 'common-components/src/obComponents/obForm'
  import ObDatePicker from 'common-components/src/obComponents/obDatePickerConstructor'
  import ObUploader from 'common-components/src/obComponents/obUploader'
  import ObStepper from 'common-components/src/obComponents/obStepper'
  import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin'
  import { required } from 'vuelidate/lib/validators'
  import moment from 'moment'

  const dateUnder = (value, vm) => {
    return Boolean(vm && (moment().startOf('day').diff(moment(value).startOf('day'), 'days') >= 0))
  }

  export default {
    name: 'confirmExecutionOrder',
    mixins: [
      FormValidationMixin
    ],
    components: {
      ObForm,
      ObDatePicker,
      ObUploader,
      ObStepper
    },
    props: {
      order: {
        type: Object,
        required: true
      },
      docsCount: {
        type: Number,
        default: 0
      }
    },
    computed: {
      ...mapGetters({}),
      formModel () {
        return {
          fileUuid: {
            value: ''
          },
          acceptedCount: {
            value: '',
            validator: {
              required
            }
          },
          receivingDate: {
            value: () => moment(),
            validator: {
              required,
              dateUnder: {
                method: dateUnder,
                error: 'Дата получение не может быть в будущем'
              }
            }
          }
        }
      },
      uploadMethod () {
        return api.files.postFile
      }
    },
    watch: {
      'formData.fileUuid' (value) {
        if (!value) {
          this.$refs.uploader && this.$refs.uploader.clearFiles()
        }
      },
    },
    methods: {
      afterInitForm () {
        this.$nextTick(() => {
          this.formData.acceptedCount = this.docsCount || 1
        })
      },
      async onUploadHandler (data) {
        data = data[0]

        if (!data) {
          this.formData.fileUuid = null
          return
        }

        this.formData.fileUuid = data.uuid
      },
      async onSubmitHandler (data) {
        this.$emit('on-submit', data)
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "~common-components/src/static/css/mixins";

  .order-request-execution {
    .row {
      margin-top: 20px!important;
      margin-bottom: 20px!important;
    }
    .title {
      margin-top: 30px;
      margin-bottom: 15px;
      @include font-mixin(16px, 24px, 600, $color-text-base , 0.4px);
    }
  }
</style>
